package video;

import futils.Futil;
import gui.run.RunJob;
import ip.gif.gifAnimation.Gif89Encoder;
import j2d.ImageUtils;
import j2d.ShortImageBean;

import java.awt.AWTException;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Vector;

/**
 * DocJava, Inc.
 * http://www.docjava.com
 * Programmer: dlyon
 * Date: Nov 23, 2004
 * Time: 1:12:41 PM
 */
public class Player {
    Vector v = new Vector();
    RunJob rj = null;

    public static void main(String[] args) {
        Player p = new Player();
        System.out.println("Recording");
        p.record(0.5);    // number of seconds per frame
        System.out.println("recording stoped");
    }

    private void record(double spf) {
                grabScreen();
                saveScreen();
    }

    private void saveScreen() {
        Futil.setSwing(false);

        File f = Futil.getWriteFile("select and output file (gif)");
        ImageUtils.saveAsGif(
                reduceColors(ImageUtils.getImage((BufferedImage)v.elementAt(0))),f);

    }

    private Image reduceColors(Image img) {
        ShortImageBean sib = new ShortImageBean(img);
        ip.color.Octree ot = new ip.color.Octree();
        ot.octreeQuantization(sib.getR(),
                sib.getG(),
                sib.getB(), 256);
        sib.swapGreenAndBlue();
        return sib.getImage();
    }

    private Image[] getImages() {
        Image imgs [] = new Image[v.size()];
        for (int i = 0; i < v.size(); i++) {
            imgs[i] = reduceColors(
                    ImageUtils.getImage((BufferedImage) v.elementAt(i)));
        }
        return imgs;
    }

    private void saveImages() throws IOException {
        File f = Futil.getWriteFile("select gif output file");
        int speed = 2; //fps
        Image img [] = getImages();
        int n = img.length;
        if (n ==0) return;
        FileOutputStream fos =
                Futil.getFileOutputStream(f);
        Gif89Encoder ge = new Gif89Encoder();
        for (int i = 1; i < n; i++) {
            ge.addFrame(img[i]);
            ge.setUniformDelay(Math.round(100 / speed));
            System.out.println("processed frame:" + i);
        }
        System.out.println("done!");
        ge.setLoopCount(true ?
                0 :
                1);
        ge.encode(fos);
        fos.close();
    }

    public void grabScreen() {
        v.addElement(getImage());
    }

    private static BufferedImage getImage() {
        try {
            return ImageUtils.captureScreen();
        } catch (AWTException e) {
            e.printStackTrace();
        }
        return null;
    }
}